<template>
  <div class="record-list">
    <contact-panel
      v-if="contact"
      :order="order"
      :type="type"
      @close="() => closeContactPanel()"
      @success="() => closeContactPanel(true)"
    />

    <contact-success-panel
      v-if="contactSuccess"
      @close="contactSuccess = false"
    />

    <record-item
      v-show="!loading"
      v-for="record in records"
      :key="record.OrderId"
      :record="record"
      :type="type"
      @openContactPanel="openContactPanel(record)"
    />

    <div v-if="loading">
      <record-item />
    </div>
    <div v-if="!records.length && !loading" class="empty">
      {{ $t("preorderRecordList.noRecords") }}
    </div>
  </div>
</template>

<script>
import RecordItem from "./RecordItem";
import ContactPanel from "@/components/Preorder/ContactPanel";
import ContactSuccessPanel from "@/components/Preorder/ContactSuccessPanel";

export default {
  components: {
    RecordItem,
    ContactPanel,
    ContactSuccessPanel
  },

  props: {
    loading: {
      type: Boolean,
      default: false
    },
    records: {
      type: Array,
      default: () => []
    },
    type: {
      type: String,
      default: ""
    }
  },

  data() {
    return {
      order: null,
      contact: false,
      contactSuccess: false
    };
  },

  methods: {
    openContactPanel(order) {
      this.order = order;
      this.contact = true;
    },

    closeContactPanel(success) {
      this.order = null;
      this.contact = false;
      if (success) {
        this.contactSuccess = true;
      }
    }
  }
};
</script>

<style lang="scss" scoped>
.empty {
  background: #ffffff;
  text-align: center;
  height: 120px;
  line-height: 120px;
  color: #9da6b9;
  border: 1px #e2e6ee solid;
  border-radius: 5px;
  margin: 10px auto 0;
  font-size: 16px;
  max-width: 355px;
}
</style>
